#include "str.h"
#include "types.h"
#include <stdlib.h>
#include <string.h>

char *sw_concat(char *a, char *b) {
	char *str;
	u32 len_a, len_b;

	len_a = strlen(a);
	len_b = strlen(b);

	str = malloc(len_a + len_b + 1);
	memcpy(str, a, len_a);
	memcpy(str + len_a, b, len_b);
	str[len_a + len_b] = 0;

	return str;
}

char *sw_concat3(char *a, char *b, char *c) {
	char *str;
	u32 len_a, len_b, len_c;

	len_a = strlen(a);
	len_b = strlen(b);
	len_c = strlen(c);

	str = malloc(len_a + len_b + len_c + 1);
	memcpy(str, a, len_a);
	memcpy(str + len_a, b, len_b);
	memcpy(str + len_a + len_b, c, len_c);
	str[len_a + len_b + len_c] = 0;

	return str;
}

char *sw_concat4(char *a, char *b, char *c, char *d) {
	char *str;
	u32 len_a, len_b, len_c, len_d;

	len_a = strlen(a);
	len_b = strlen(b);
	len_c = strlen(c);
	len_d = strlen(d);

	str = malloc(len_a + len_b + len_c + len_d + 1);
	memcpy(str, a, len_a);
	memcpy(str + len_a, b, len_b);
	memcpy(str + len_a + len_b, c, len_c);
	memcpy(str + len_a + len_b + len_c, d, len_d);
	str[len_a + len_b + len_c + len_d] = 0;

	return str;
}

char *sw_strdup(char *str) {
	char *out;
	u32 len;

	len = strlen(str) + 1;

	out = malloc(len);
	memcpy(out, str, len);
	return out;
}
